#pragma once
#include "ParamBase.h"
#include <string>

namespace ffgl
{
class ParamText : public ParamBase
{
public:
	ParamText( const std::string& name, const std::string& defaultText = std::string() );

	~ParamText();

	void Reset() override;
	const std::string& GetDisplay() const override;
	FFMixed GetMixedDefault() const override;
	FFMixed GetMixedValue() const override;
	FFResult SetMixedValue( const FFMixed mixed ) override;

	virtual const std::string& GetDefaultText() const;
	virtual const std::string& GetText() const;
	virtual void SetText( const std::string& textValue );

protected:
	std::string text;
	std::string defaultText;
};

}//End namespace ffgl
